

<!DOCTYPE html>
<!--[if IE 8]><html class="no-js lt-ie9" lang="en" > <![endif]-->
<!--[if gt IE 8]><!--> <html class="no-js" lang="en" > <!--<![endif]-->
<head>
  <meta charset="utf-8">
  
  <meta name="viewport" content="width=device-width, initial-scale=1.0">
  
  <title>Resource Management Board Configuration &mdash; TISCI User Guide</title>
  

  
  
    <link rel="shortcut icon" href="../_static/favicon.ico"/>
  

  

  
  
    

  

  
  
    <link rel="stylesheet" href="../_static/css/theme.css" type="text/css" />
  

  
    <link rel="stylesheet" href="../_static/theme_overrides.css" type="text/css" />
  

  
        <link rel="index" title="Index"
              href="../genindex.html"/>
        <link rel="search" title="Search" href="../search.html"/>
    <link rel="top" title="TISCI User Guide" href="../index.html"/>
        <link rel="up" title="Chapter 3: Board Configuration" href="index.html"/>
        <link rel="next" title="Security Board Configuration" href="BOARDCFG_SEC.html"/>
        <link rel="prev" title="Board Configuration" href="BOARDCFG.html"/> 

  
  <script src="../_static/js/modernizr.min.js"></script>

</head>

<body class="wy-body-for-nav" role="document">
  <header id="tiHeader">
    <div class="top">
      <ul>
        <li id="top_logo">
          <a href="http://www.ti.com">
            <img src="../_static/img/ti_logo.png"/>
          </a>
        </li>
      </ul>
    </div>
    <div class="nav"></div>
  </header>
  <div class="wy-grid-for-nav">

    
    <nav data-toggle="wy-nav-shift" class="wy-nav-side">
      <div class="wy-side-scroll">
        <div class="wy-side-nav-search">
          

          
            <a href="../index.html" class="icon icon-home"> TISCI
          

          
          </a>

          
            
            
              <div class="version">
                11.00.04
              </div>
            
          

          
<div role="search">
  <form id="rtd-search-form" class="wy-form" action="../search.html" method="get">
    <input type="text" name="q" placeholder="Search docs" />
    <input type="hidden" name="check_keywords" value="yes" />
    <input type="hidden" name="area" value="default" />
  </form>
</div>

          
        </div>

        <div class="wy-menu wy-menu-vertical" data-spy="affix" role="navigation" aria-label="main navigation">
          
            
            
                <ul class="current">
<li class="toctree-l1"><a class="reference internal" href="../1_intro/index.html">Chapter 1: Introduction</a></li>
<li class="toctree-l1"><a class="reference internal" href="../2_tisci_msgs/index.html">Chapter 2: TISCI Message Documentation</a></li>
<li class="toctree-l1 current"><a class="reference internal" href="index.html">Chapter 3: Board Configuration</a><ul class="current">
<li class="toctree-l2"><a class="reference internal" href="BOARDCFG.html">Board Configuration</a></li>
<li class="toctree-l2 current"><a class="current reference internal" href="#">Resource Management Board Configuration</a><ul>
<li class="toctree-l3"><a class="reference internal" href="#introduction">Introduction</a><ul>
<li class="toctree-l4"><a class="reference internal" href="#device-groups-for-resource-management-board-configuration">Device Groups for Resource Management Board Configuration</a></li>
<li class="toctree-l4"><a class="reference internal" href="#static-resource-assignment-configurations">Static Resource Assignment Configurations</a></li>
<li class="toctree-l4"><a class="reference internal" href="#high-level-parts-of-rm-board-configuration">High Level Parts of RM Board Configuration</a></li>
</ul>
</li>
<li class="toctree-l3"><a class="reference internal" href="#pc-based-pre-processing-the-rm-board-configuration">PC based Pre-processing the RM Board Configuration</a><ul>
<li class="toctree-l4"><a class="reference internal" href="#resource-assignment-validation">Resource Assignment Validation</a></li>
<li class="toctree-l4"><a class="reference internal" href="#tisci-api-for-resource-management-board-config">TISCI API for Resource Management Board Config</a></li>
<li class="toctree-l4"><a class="reference internal" href="#ti-sci-api-for-get-resource-assignment-range">TI-SCI API for Get Resource Assignment Range</a></li>
<li class="toctree-l4"><a class="reference internal" href="#id1">Usage</a></li>
<li class="toctree-l4"><a class="reference internal" href="#id2">TISCI Message ID</a></li>
<li class="toctree-l4"><a class="reference internal" href="#id3">Message Data Structures</a></li>
</ul>
</li>
<li class="toctree-l3"><a class="reference internal" href="#resource-management-initialization-after-receiving-board-configuration">Resource Management Initialization after receiving board configuration</a><ul>
<li class="toctree-l4"><a class="reference internal" href="#board-configuration-receive-and-validate">Board Configuration Receive and Validate</a></li>
<li class="toctree-l4"><a class="reference internal" href="#rm-core-initialization">RM Core Initialization</a></li>
<li class="toctree-l4"><a class="reference internal" href="#rm-irq-initialization">RM IRQ Initialization</a></li>
<li class="toctree-l4"><a class="reference internal" href="#rm-ring-accelerator-initialization">RM Ring Accelerator initialization</a></li>
<li class="toctree-l4"><a class="reference internal" href="#rm-dma-initialization">RM DMA Initialization</a></li>
<li class="toctree-l4"><a class="reference internal" href="#rm-psil-initialization">RM PSIL Initialization</a></li>
<li class="toctree-l4"><a class="reference internal" href="#rm-proxy-initialization">RM Proxy Initialization</a></li>
<li class="toctree-l4"><a class="reference internal" href="#osal-rm-subsystem-init">OSAL RM Subsystem Init</a></li>
</ul>
</li>
</ul>
</li>
<li class="toctree-l2"><a class="reference internal" href="BOARDCFG_SEC.html">Security Board Configuration</a></li>
<li class="toctree-l2"><a class="reference internal" href="BOARDCFG_PM.html">Power Management Board Configuration</a></li>
<li class="toctree-l2"><a class="reference internal" href="BOARDCFG_COMBINED_IMG_FORMAT.html">Board Configuration with ROM Combined Image format</a></li>
</ul>
</li>
<li class="toctree-l1"><a class="reference internal" href="../4_trace/index.html">Chapter 4: Interpreting Trace Data</a></li>
<li class="toctree-l1"><a class="reference internal" href="../5_soc_doc/index.html">Chapter 5: SoC Family Specific Documentation</a></li>
<li class="toctree-l1"><a class="reference internal" href="../6_topic_user_guides/index.html">Chapter 6: Topic User Guides</a></li>
</ul>

            
          
        </div>
      </div>
    </nav>

    <section data-toggle="wy-nav-shift" class="wy-nav-content-wrap">

      
      <nav class="wy-nav-top" role="navigation" aria-label="top navigation">
        <i data-toggle="wy-nav-top" class="fa fa-bars"></i>
        <a href="../index.html">TISCI</a>
      </nav>


      
      <div class="wy-nav-content">
        <div class="rst-content">
          

 



<div role="navigation" aria-label="breadcrumbs navigation">
  <ul class="wy-breadcrumbs">
    <li><a href="../index.html">Docs</a> &raquo;</li>
      
          <li><a href="index.html">Chapter 3: Board Configuration</a> &raquo;</li>
      
    <li>Resource Management Board Configuration</li>
      <li class="wy-breadcrumbs-aside">
        
          
        
      </li>
  </ul>
  <hr/>
</div>
          <div role="main" class="document" itemscope="itemscope" itemtype="http://schema.org/Article">
           <div itemprop="articleBody">
            
  <div class="section" id="resource-management-board-configuration">
<h1>Resource Management Board Configuration<a class="headerlink" href="#resource-management-board-configuration" title="Permalink to this headline">¶</a></h1>
<div class="section" id="introduction">
<h2>Introduction<a class="headerlink" href="#introduction" title="Permalink to this headline">¶</a></h2>
<p>The RM board configuration message initializes the RM subsystem and
contains the host configuration attributes and the resource assignment data.
The RM subsystem is not considered functional until after the RM board
configuration message is received by DMSC.  The RM board configuration data can
be sent any time after the standard boardcfg message, <a class="reference internal" href="BOARDCFG.html#pub-boardcfg-cfg"><span class="std std-ref">Configuration substructure enumeration</span></a>
is received.</p>
<p>The resource management data is placed into regular
memory by the host software, made coherent (writeback and fences as required by
host architecture) then passed to System Firmware via
<a class="reference internal" href="#pub-boardcfg-rm-tisci"><span class="std std-ref">TISCI_MSG_BOARD_CONFIG_RM</span></a>.  On HS devices, the
board config blob is signed and encrypted using customer root
public key and customer encryption key for HS-SE devices. For HS-FS and
GP devices there are no customer keys, therefore board config must be
unsigned and plain text. Please refer to <a class="reference internal" href="../6_topic_user_guides/hs_boardcfg_signing.html"><span class="doc">Signing Board Configuration on HS devices</span></a> on how to sign and encrypt
board configuration on HS devices.</p>
<p>The resource management data is provided separately to reduce DMSC boot time.
The resource management board cfg message is sent any time after the boot
notification message is sent and has no dependence upon reception of the
standard board configuration message,
<a class="reference internal" href="BOARDCFG.html#pub-boardcfg-tisci"><span class="std std-ref">TISCI_MSG_BOARD_CONFIG</span></a>.</p>
<p>RM board configuration contains static assignments of resources to hosts via
the resource assignment data.  The resource
assignment data format is described by <a class="reference internal" href="#pub-boardcfg-rm-resasg"><span class="std std-ref">boardcfg_rm_resasg structure</span></a> which
defines a variable length array at the end of the RM board cfg data structure.
Users must append a fixed length array to the end <a class="reference internal" href="#pub-boardcfg-rm"><span class="std std-ref">boardcfg_rm structure</span></a> to
represent the resource assignment data array.  The resource
assignment array is a list of <a class="reference internal" href="#pub-boardcfg-rm-resasg-entry"><span class="std std-ref">boardcfg_rm_resasg_entry (resource assignment) structure</span></a> elements.  The
current maximum number of elements allowed in the resource assignment array is
defined in the SoC-specific RM resource types documentation.  The number of
elements in the array are defined on an SoC basis based on expected use cases.
Resource assignment lists sized greater than what is expected will have the RM
boardcfg message NACK’d.</p>
<p>Assigned resource ranges are retrievable at runtime by sending System Firmware
a request via
<a class="reference internal" href="#pub-boardcfg-resasg-get-tisci"><span class="std std-ref">TISCI_MSG_RM_GET_RESOURCE_RANGE</span></a>.  The
specified resource type’s range is returned for the host who sent the request.</p>
<div class="admonition warning">
<p class="first admonition-title">Warning</p>
<p class="last">Currently the RESASG_SUBTYPE_RA_MONITORS resource can only be
assigned to a single host in SoC RM board configurations due to
constraints in the number of host entries allowed in channelized
firewall programming.</p>
</div>
<div class="section" id="device-groups-for-resource-management-board-configuration">
<h3>Device Groups for Resource Management Board Configuration<a class="headerlink" href="#device-groups-for-resource-management-board-configuration" title="Permalink to this headline">¶</a></h3>
<p>The RM board configuration TISCI message allows the user to specify the DEVGRP
under which the RM subsystem operates.  A specified DEVGRP defines which RM
driver instances are capable of usage by the host applications.  The host
application can implement RM subsystem DEVGRP usage by sending a
“ref”<cite>TISCI_MSG_RM_BOARD_CONFIG_RM &lt;pub_boardcfg_rm_tisci&gt;</cite> message with the
boardcfg_rm_devgrp parameter populated with one or more SoC-specific device
group values.  The DEVGRP value specifying whole device is mapped to zero so
existing RM board configurations not explicitly defining a DEVGRP for the
boardcfg_rm_devgrp parameter will be backwards compatible.</p>
<p>DEVGRPS are cumulative so if multiple RM board configurations are received,
each with a unique DEVGRP defined, all received DEVGRPs will be active.  To
support accumulation of DEVGRPs the RM board configuration message can be sent
any number of times.  However, board configuration content pointed to by the
message is copied and validated when only the first board configuration message
is received.  All subsequent messages only serve to update the RM subsystem
DEVGRP.</p>
</div>
<div class="section" id="static-resource-assignment-configurations">
<span id="pub-boardcfg-rm-resasg-cfg"></span><h3>Static Resource Assignment Configurations<a class="headerlink" href="#static-resource-assignment-configurations" title="Permalink to this headline">¶</a></h3>
<p>The RM board configuration static resource assignment functionality supports
the following range assignment configurations.</p>
<ul>
<li><p class="first">Single owner assignments (Most common use case, recommended configuration
whenever possible):</p>
<ul class="simple">
<li>Every SoC host ID can be assigned no more than one resource range per
resource type.  At DMSC init, firewalls are configured to allow host IDs
access to all resource ranges they’ve been assigned.  The RM subsystem
cannot guarantee resource range query response and resource configuration
for ranges defined beyond the first for a host ID.</li>
</ul>
</li>
<li><p class="first">Dual owner assignments (Niche use case when two hosts require access and
configuration rights to a resource):</p>
<ul>
<li><p class="first">An overlap between two resource ranges can be defined for two host IDs.
Resource firewalls allow up to two unique hosts to access a resource.
Overlapping ranges between host IDs allows both host IDs to configure
non-real-time registers and access the real-time registers.</p>
<p>The RM boardcfg TISCI message is NACK’d if an overlap of more than two
range definitions per resource type is detected.</p>
</li>
</ul>
</li>
<li><p class="first">Open access assignments (Extremely niche use cases where all hosts require
access and configuration rights to a resource):</p>
<ul class="simple">
<li>The HOST_ID_ALL host ID can be used to assign a range of resources for use by
all host IDs.  In this case, the firewall is configured to allow all hosts
to access a resource.  This feature must be used judiciously, only for
resources that must be shared by more than two host IDs.  Management of
resources within a range assigned to HOST_ID_ALL is performed by the user
application.</li>
<li>A resource range assigned to HOST_ID_ALL cannot overlap with another resource
range.  The RM boardcfg TISCI message is NACK’d if an overlap with a range
assigned to HOST_ID_ALL is detected.</li>
<li>Populate the secondary_host parameter of the
tisci_msg_rm_get_resource_range_req TISCI message API with HOST_ID_ALL in
order to retrieve the range assigned to HOST_ID_ALL for a resource type.</li>
</ul>
</li>
</ul>
<div class="admonition warning">
<p class="first admonition-title">Warning</p>
<p class="last">The RM Board Configuration message MUST be sent in order to initialize the Resource Management
capabilities of system firmware. Until it is received no Resource Management
services are available.</p>
</div>
<div class="admonition warning">
<p class="first admonition-title">Warning</p>
<p class="last">The first Resource Management board configuration message received is rejected
if resource assignment data is not sent and does not conform to the resource
assignment validation guidelines.  Please see
<a class="reference internal" href="#pub-boardcfg-rm-resasg-validation"><span class="std std-ref">Resource Assignment Validation</span></a> for a description of the resource
assignment data validation guidelines.</p>
</div>
<div class="admonition warning">
<p class="first admonition-title">Warning</p>
<p class="last">There are limitations when using HOST_ID_ALL as the owner of a resource
range assignment.  Please see <a class="reference internal" href="#pub-boardcfg-rm-resasg-cfg"><span class="std std-ref">Static Resource Assignment Configurations</span></a> for a
description on the use cases and limitations behind different resource
range configurations.</p>
</div>
</div>
<div class="section" id="high-level-parts-of-rm-board-configuration">
<h3>High Level Parts of RM Board Configuration<a class="headerlink" href="#high-level-parts-of-rm-board-configuration" title="Permalink to this headline">¶</a></h3>
<p>The RM board configuration consists of 2 parts: (1) host configuration attributes
and (2) resource assignment.</p>
<p>The host configuration attributes portion of the RM board configuration
statically defines the allowed values for:</p>
<ul class="simple">
<li>Order IDs</li>
<li>QoS levels</li>
<li>Bus priorities</li>
<li>Scheduling priorities</li>
<li>Atype</li>
</ul>
<p>Allowed values are defined for each host ID supported.</p>
<p>Applications are able to query DMSC for the allowed values assigned to hosts
for runtime discovery of a host’s attributes.</p>
<p>The resource assignment portion of the RM board configuration statically defines
usage of resource ranges for use by all SoC hosts.  The resource management
subsystem references the resource assignment board configuration for all
resource configuration requests.</p>
<p>Applications are able to query DMSC for the resource ranges assigned to hosts
allowing runtime discovery of assigned resources.</p>
<p>Please see <a class="reference internal" href="BOARDCFG.html"><span class="doc">Board Configuration</span></a> for information on the overall
Board Configuration.</p>
</div>
</div>
<div class="section" id="pc-based-pre-processing-the-rm-board-configuration">
<h2>PC based Pre-processing the RM Board Configuration<a class="headerlink" href="#pc-based-pre-processing-the-rm-board-configuration" title="Permalink to this headline">¶</a></h2>
<p>The RM board configuration data should be sorted and indexed for faster
runtime access. The sorted array must be in ascending resource
type order.  Then within each resource type the entries must be sorted in
ascending start_resource value order. The user must ensure the RM board
configuration is sorted based on the flow shown below before sending this to the
System Firmware. The overall flow for creating the board configuration and generating
the pre-sorted and validated RM board configuration binary blob is as shown below.</p>
<img alt="../_images/RM_BRD_CFG_1.JPG" src="../_images/RM_BRD_CFG_1.JPG" />
<p>Details on how to use the sysfw_boardcfg_validator.py can be found by using the
“–help” option to the script. The details on how to use this script is as shown
below:</p>
<div class="code c highlight-cpp"><div class="highlight"><pre><span></span><span class="nl">usage</span><span class="p">:</span><span class="w"> </span><span class="n">sysfw_boardcfg_validator</span><span class="p">.</span><span class="n">py</span><span class="w"> </span><span class="p">[</span><span class="o">-</span><span class="n">h</span><span class="p">]</span><span class="w"> </span><span class="o">-</span><span class="n">b</span><span class="w"> </span><span class="n">BINARY_FILE</span><span class="w"> </span><span class="o">-</span><span class="n">s</span>
<span class="w">                                        </span><span class="p">{</span><span class="n">am65x_sr2</span><span class="p">,</span><span class="n">j721e</span><span class="p">,</span><span class="n">am6</span><span class="p">}</span>
<span class="w">                                        </span><span class="p">(</span><span class="o">-</span><span class="n">l</span><span class="w"> </span><span class="n">LOG_OUTPUT_FILE</span><span class="w"> </span><span class="o">|</span><span class="w"> </span><span class="o">-</span><span class="n">L</span><span class="p">)</span>
<span class="w">                                        </span><span class="p">[</span><span class="o">-</span><span class="n">o</span><span class="w"> </span><span class="n">OUTPUT_BINARY_FILE</span><span class="p">]</span><span class="w"> </span><span class="p">[</span><span class="o">-</span><span class="n">r</span><span class="w"> </span><span class="n">RULES_FILE</span><span class="p">]</span>
<span class="w">                                        </span><span class="p">[</span><span class="o">-</span><span class="n">i</span><span class="p">]</span>

<span class="n">System</span><span class="w"> </span><span class="n">Firmware</span><span class="w"> </span><span class="n">Board</span><span class="w"> </span><span class="n">Configuration</span><span class="w"> </span><span class="n">Validator</span><span class="w"> </span><span class="n">URL</span><span class="o">:</span><span class="w"> </span><span class="n">http</span><span class="o">:</span><span class="c1">//software-</span>
<span class="n">dl</span><span class="p">.</span><span class="n">ti</span><span class="p">.</span><span class="n">com</span><span class="o">/</span><span class="n">tisci</span><span class="o">/</span><span class="n">esd</span><span class="o">/</span><span class="n">latest</span><span class="o">/</span><span class="mi">3</span><span class="n">_boardcfg</span><span class="o">/</span><span class="n">BOARDCFG</span><span class="p">.</span><span class="n">html</span>

<span class="n">Required</span><span class="w"> </span><span class="n">arguments</span><span class="w"> </span><span class="o">-</span><span class="w"> </span><span class="n">Define</span><span class="w"> </span><span class="n">the</span><span class="w"> </span><span class="n">inputs</span><span class="o">:</span>
<span class="w">  </span><span class="o">-</span><span class="n">b</span><span class="w"> </span><span class="n">BINARY_FILE</span><span class="p">,</span><span class="w"> </span><span class="o">--</span><span class="n">binary_file</span><span class="w"> </span><span class="n">BINARY_FILE</span>
<span class="w">                        </span><span class="n">Binary</span><span class="w"> </span><span class="n">File</span><span class="w"> </span><span class="n">provided</span><span class="w"> </span><span class="n">as</span><span class="w"> </span><span class="n">input</span><span class="w"> </span><span class="p">(</span><span class="k">default</span><span class="o">:</span><span class="w"> </span><span class="n">None</span><span class="p">)</span>
<span class="w">  </span><span class="o">-</span><span class="n">s</span><span class="w"> </span><span class="p">{</span><span class="n">am65x_sr2</span><span class="p">,</span><span class="n">j721e</span><span class="p">,</span><span class="n">am6</span><span class="p">},</span><span class="w"> </span><span class="o">--</span><span class="n">soc</span><span class="w"> </span><span class="p">{</span><span class="n">am65x_sr2</span><span class="p">,</span><span class="n">j721e</span><span class="p">,</span><span class="n">am6</span><span class="p">}</span>
<span class="w">                        </span><span class="n">SoC</span><span class="w"> </span><span class="n">supported</span><span class="w"> </span><span class="n">by</span><span class="w"> </span><span class="n">input</span><span class="w"> </span><span class="n">binary</span><span class="w"> </span><span class="p">(</span><span class="k">default</span><span class="o">:</span><span class="w"> </span><span class="n">None</span><span class="p">)</span>

<span class="n">Required</span><span class="w"> </span><span class="n">arguments</span><span class="w"> </span><span class="o">-</span><span class="w"> </span><span class="n">Choose</span><span class="w"> </span><span class="n">one</span><span class="w"> </span><span class="n">of</span><span class="w"> </span><span class="n">the</span><span class="w"> </span><span class="n">outputs</span><span class="o">:</span>
<span class="w">  </span><span class="o">-</span><span class="n">l</span><span class="w"> </span><span class="n">LOG_OUTPUT_FILE</span><span class="p">,</span><span class="w"> </span><span class="o">--</span><span class="n">log_output_file</span><span class="w"> </span><span class="n">LOG_OUTPUT_FILE</span>
<span class="w">                        </span><span class="n">Validation</span><span class="w"> </span><span class="n">log</span><span class="w"> </span><span class="n">output</span><span class="w"> </span><span class="n">file</span><span class="w"> </span><span class="p">(</span><span class="k">default</span><span class="o">:</span><span class="w"> </span><span class="n">None</span><span class="p">)</span>
<span class="w">  </span><span class="o">-</span><span class="n">L</span><span class="p">,</span><span class="w"> </span><span class="o">--</span><span class="n">log_output_console</span>
<span class="w">                        </span><span class="n">Report</span><span class="w"> </span><span class="n">results</span><span class="w"> </span><span class="n">to</span><span class="w"> </span><span class="n">console</span><span class="w"> </span><span class="p">(</span><span class="k">default</span><span class="o">:</span><span class="w"> </span><span class="n">False</span><span class="p">)</span>

<span class="n">optional</span><span class="w"> </span><span class="n">arguments</span><span class="o">:</span>
<span class="w">  </span><span class="o">-</span><span class="n">h</span><span class="p">,</span><span class="w"> </span><span class="o">--</span><span class="n">help</span><span class="w">            </span><span class="n">show</span><span class="w"> </span><span class="k">this</span><span class="w"> </span><span class="n">help</span><span class="w"> </span><span class="n">message</span><span class="w"> </span><span class="n">and</span><span class="w"> </span><span class="n">exit</span>
<span class="w">  </span><span class="o">-</span><span class="n">o</span><span class="w"> </span><span class="n">OUTPUT_BINARY_FILE</span><span class="p">,</span><span class="w"> </span><span class="o">--</span><span class="n">output_binary_file</span><span class="w"> </span><span class="n">OUTPUT_BINARY_FILE</span>
<span class="w">                        </span><span class="n">Binary</span><span class="w"> </span><span class="n">output</span><span class="w"> </span><span class="n">file</span><span class="p">.</span><span class="w"> </span><span class="n">Inline</span><span class="w"> </span><span class="n">edit</span><span class="w"> </span><span class="n">options</span><span class="w"> </span><span class="n">of</span><span class="w"> </span><span class="n">the</span><span class="w"> </span><span class="n">binary</span>
<span class="w">                        </span><span class="n">board</span><span class="w"> </span><span class="n">configuration</span><span class="w"> </span><span class="n">data</span><span class="w"> </span><span class="n">are</span><span class="w"> </span><span class="n">output</span><span class="w"> </span><span class="n">to</span><span class="w"> </span><span class="k">this</span><span class="w"> </span><span class="n">file</span>
<span class="w">                        </span><span class="p">(</span><span class="k">default</span><span class="o">:</span><span class="w"> </span><span class="n">None</span><span class="p">)</span>
<span class="w">  </span><span class="o">-</span><span class="n">r</span><span class="w"> </span><span class="n">RULES_FILE</span><span class="p">,</span><span class="w"> </span><span class="o">--</span><span class="n">rules_file</span><span class="w"> </span><span class="n">RULES_FILE</span>
<span class="w">                        </span><span class="n">Alternate</span><span class="w"> </span><span class="n">Board</span><span class="w"> </span><span class="n">configuration</span><span class="w"> </span><span class="n">rules</span><span class="w"> </span><span class="n">file</span><span class="w"> </span><span class="p">(</span><span class="k">default</span><span class="o">:</span>
<span class="w">                        </span><span class="o">/</span><span class="n">home</span><span class="o">/</span><span class="n">piyali</span><span class="o">/</span><span class="n">WORK</span><span class="o">/</span><span class="n">PROJECTS</span><span class="o">/</span><span class="n">SYSFW</span><span class="o">/</span><span class="n">system</span><span class="o">-</span><span class="n">firmware</span><span class="o">-</span>
<span class="w">                        </span><span class="n">tools</span><span class="o">/</span><span class="n">system</span><span class="o">-</span><span class="n">firmware</span><span class="o">-</span>
<span class="w">                        </span><span class="n">releases</span><span class="o">/</span><span class="n">binaries</span><span class="o">/</span><span class="n">scripts</span><span class="o">/</span><span class="n">sysfw_boardcfg_rules</span><span class="p">.</span><span class="n">json</span><span class="p">)</span>
<span class="w">  </span><span class="o">-</span><span class="n">i</span><span class="p">,</span><span class="w"> </span><span class="o">--</span><span class="n">inline_sort</span><span class="w">     </span><span class="n">Perform</span><span class="w"> </span><span class="n">an</span><span class="w"> </span><span class="kr">inline</span><span class="w"> </span><span class="n">sort</span><span class="w"> </span><span class="n">of</span><span class="w"> </span><span class="n">the</span><span class="w"> </span><span class="n">Resource</span><span class="w"> </span><span class="n">Management</span>
<span class="w">                        </span><span class="n">board</span><span class="w"> </span><span class="n">configuration</span><span class="w"> </span><span class="n">resource</span><span class="w"> </span><span class="n">assignments</span><span class="p">.</span><span class="w"> </span><span class="n">The</span><span class="w"> </span><span class="o">-</span><span class="n">o</span>
<span class="w">                        </span><span class="n">option</span><span class="w"> </span><span class="n">must</span><span class="w"> </span><span class="n">be</span><span class="w"> </span><span class="n">specified</span><span class="w"> </span><span class="n">to</span><span class="w"> </span><span class="n">output</span><span class="w"> </span><span class="n">result</span><span class="w"> </span><span class="n">of</span><span class="w"> </span><span class="n">sort</span>
<span class="w">                        </span><span class="p">(</span><span class="k">default</span><span class="o">:</span><span class="w"> </span><span class="n">False</span><span class="p">)</span>
</pre></div>
</div>
<div class="section" id="resource-assignment-validation">
<span id="pub-boardcfg-rm-resasg-validation"></span><h3>Resource Assignment Validation<a class="headerlink" href="#resource-assignment-validation" title="Permalink to this headline">¶</a></h3>
<p>The resource assignment data is validated by the sysfw_boardcfg_validator.py script.
The resource data is validated to prevent RM resource assignment
errors that can cause operational failures during post-initialization runtime
of the SoC applications.  Validation criteria are:</p>
<ul class="simple">
<li>The resource assignment substructure header magic number must match the
magic number defined for the RM boardcfg resource assignment substructure</li>
<li>The resource assignment substructure header size must match the size of
<a class="reference internal" href="#pub-boardcfg-rm-resasg"><span class="std std-ref">boardcfg_rm_resasg substructure</span></a> definition.</li>
<li>The resource assignment entry array size in bytes cannot be zero.  The RM
subsystem requires a resource assignment array in order to operate.  Passing
no resource assignments causes the RM boardcfg message to be rejected.</li>
<li>The resource assignment entry array size cannot be greater than the size of
the DMSC internal storage for the resource assignment array.</li>
<li>The resource assignment entry array size must be a multiple of the
<a class="reference internal" href="#pub-boardcfg-rm-resasg-entry"><span class="std std-ref">boardcfg_rm_resasg_entry</span></a> size</li>
<li>Resource assignments can overlap to assign resources to multiple hosts
according to <a class="reference internal" href="#pub-boardcfg-rm-resasg-cfg"><span class="std std-ref">Static Resource Assignment Configurations</span></a>.
The overlap validation criteria:<ul>
<li>No more than two resource ranges of the same resource type can overlap</li>
<li>Overlapping resource ranges of the same resource type cannot be assigned to
the same Host ID</li>
<li>Resource ranges assigned to the HOST_ID_ALL Host ID cannot overlap with
any other resource ranges of the same resource type</li>
</ul>
</li>
<li>Resource assignment ranges and types are checked by the RM subsystem drivers
to make sure they are valid according to the SoC resources managed by each
driver.  The RM boardcfg message is rejected if a resource range is found to
not have a valid type or resource range for the SoC managed resources.</li>
<li>Resource assignment ranges and types are checked by the RM subsystem drivers
to verify the ranges is not assignment usage of a DMSC reserved resource to
a SoC Host ID.  The RM boardcfg message is rejected if a resource range
assigns a DMSC reserved resource to a Host ID.  Any resource defined as
“Reserved for use by DMSC” in the SoC Family Specific Documentation section
of the user guide cannot be part of a resource assignment entry.</li>
</ul>
</div>
<div class="section" id="tisci-api-for-resource-management-board-config">
<span id="pub-boardcfg-rm-tisci"></span><h3>TISCI API for Resource Management Board Config<a class="headerlink" href="#tisci-api-for-resource-management-board-config" title="Permalink to this headline">¶</a></h3>
<p>The following are the parameters required in the TI-SCI message to pass
RM resource management board configuration data to DMSC after DMSC sends boot
notification complete.  The resource management board configuration message
is not dependent on reception of the standard board configuration message.</p>
<div class="section" id="usage">
<h4>Usage<a class="headerlink" href="#usage" title="Permalink to this headline">¶</a></h4>
<table border="1" class="docutils">
<colgroup>
<col width="75%" />
<col width="25%" />
</colgroup>
<tbody valign="top">
<tr class="row-odd"><td><strong>Message Type</strong></td>
<td>Normal</td>
</tr>
<tr class="row-even"><td><strong>Secure Queue Only?</strong></td>
<td>No</td>
</tr>
</tbody>
</table>
</div>
<div class="section" id="tisci-message-id">
<h4>TISCI Message ID<a class="headerlink" href="#tisci-message-id" title="Permalink to this headline">¶</a></h4>
<p><code class="docutils literal"><span class="pre">TISCI_MSG_BOARD_CONFIG_RM</span>&#160;&#160;&#160;&#160;&#160;&#160;&#160;&#160;&#160; <span class="pre">(0x000CU)</span></code></p>
</div>
<div class="section" id="message-data-structures">
<h4>Message Data Structures<a class="headerlink" href="#message-data-structures" title="Permalink to this headline">¶</a></h4>
<p><p><strong>struct tisci_msg_board_config_rm_req</strong></p>
<p>TISCI_MSG_BOARD_CONFIG_RM request to provide the location and size of the boardcfg Resource Management configuration structure.</p>
<table border="1" class="docutils">
<colgroup>
<col width="18%" />
<col width="19%" />
<col width="63%" />
</colgroup>
<thead valign="bottom">
<tr class="row-odd"><th class="head">Parameter</th>
<th class="head">Type</th>
<th class="head">Description</th>
</tr>
</thead>
<tbody valign="top">
<tr class="row-even"><td>hdr</td>
<td>struct tisci_header</td>
<td>TISCI header</td>
</tr>
<tr class="row-odd"><td>boardcfg_rmp_low</td>
<td>u32</td>
<td>Low 32-bits of physical pointer to boardcfg RM configuration struct.</td>
</tr>
<tr class="row-even"><td>boardcfg_rmp_high</td>
<td>u32</td>
<td>High 32-bits of physical pointer to boardcfg RM configuration struct.</td>
</tr>
<tr class="row-odd"><td>boardcfg_rm_size</td>
<td>u16</td>
<td>Size of RM configuration data.</td>
</tr>
<tr class="row-even"><td>boardcfg_rm_devgrp</td>
<td>devgrp_t</td>
<td>Device group for the RM configuration.</td>
</tr>
</tbody>
</table>
</p>
<p><p><strong>struct tisci_msg_board_config_rm_resp</strong></p>
<p>Empty response for TISCI_MSG_BOARD_CONFIG_RM.</p>
<table border="1" class="docutils">
<colgroup>
<col width="27%" />
<col width="43%" />
<col width="31%" />
</colgroup>
<thead valign="bottom">
<tr class="row-odd"><th class="head">Parameter</th>
<th class="head">Type</th>
<th class="head">Description</th>
</tr>
</thead>
<tbody valign="top">
<tr class="row-even"><td>hdr</td>
<td>struct tisci_header</td>
<td>TISCI header.</td>
</tr>
</tbody>
</table>
<p>Although this message is essentially empty and contains only a header
 a full data structure is created for consistency in implementation.</p>
</p>
</div>
</div>
<div class="section" id="ti-sci-api-for-get-resource-assignment-range">
<span id="pub-boardcfg-resasg-get-tisci"></span><h3>TI-SCI API for Get Resource Assignment Range<a class="headerlink" href="#ti-sci-api-for-get-resource-assignment-range" title="Permalink to this headline">¶</a></h3>
<p>The following are the parameters required in the TI-SCI message to retrieve
the range of a specific resource assigned to a host.</p>
</div>
<div class="section" id="id1">
<h3>Usage<a class="headerlink" href="#id1" title="Permalink to this headline">¶</a></h3>
<table border="1" class="docutils">
<colgroup>
<col width="75%" />
<col width="25%" />
</colgroup>
<tbody valign="top">
<tr class="row-odd"><td><strong>Message Type</strong></td>
<td>Normal</td>
</tr>
<tr class="row-even"><td><strong>Secure Queue Only?</strong></td>
<td>No</td>
</tr>
</tbody>
</table>
</div>
<div class="section" id="id2">
<h3>TISCI Message ID<a class="headerlink" href="#id2" title="Permalink to this headline">¶</a></h3>
<p><p><code class="docutils literal"><span class="pre">TISCI_MSG_RM_GET_RESOURCE_RANGE</span>&#160;&#160;&#160;&#160;&#160;&#160;&#160;&#160;&#160; <span class="pre">(0x1500U)</span></code></p>
<p>RM TISCI message to request a resource range assignment for a host</p>
</p>
</div>
<div class="section" id="id3">
<h3>Message Data Structures<a class="headerlink" href="#id3" title="Permalink to this headline">¶</a></h3>
<p><p><strong>struct tisci_msg_rm_get_resource_range_req</strong></p>
<p>Retrieves a host’s assigned range for a resource</p>
<table border="1" class="docutils">
<colgroup>
<col width="6%" />
<col width="8%" />
<col width="86%" />
</colgroup>
<thead valign="bottom">
<tr class="row-odd"><th class="head">Parameter</th>
<th class="head">Type</th>
<th class="head">Description</th>
</tr>
</thead>
<tbody valign="top">
<tr class="row-even"><td>hdr</td>
<td>struct tisci_header</td>
<td>Standard TISCI header</td>
</tr>
<tr class="row-odd"><td>type</td>
<td>u16</td>
<td>Resource assignment type used to form unique resource type.  Only 10 LSB are valid.  Types are found in the “Enumeration of Resource Type IDs” section of the DMSC public document.</td>
</tr>
<tr class="row-even"><td>subtype</td>
<td>u8</td>
<td>Resource assignment subtype used to form unique resource type.  Only 6 LSB are valid.  Subtypes are found in the “Enumeration of Resource Type IDs” section of the DMSC public document.</td>
</tr>
<tr class="row-odd"><td>secondary_host</td>
<td>u8</td>
<td>The host processing entity attempting to allocate the ring if not set to &#64;ref TISCI_MSG_VALUE_RM_UNUSED_SECONDARY_HOST.  Otherwise, the host within the TISCI message header is the host attempting to allocate the ring.</td>
</tr>
</tbody>
</table>
<p>Returns the range for a unique resource type assigned to the specified host,
 or secondary host.  The unique resource type is formed by combining the
 10 LSB of type and the 6 LSB of subtype.
 Unique types which do not map to an SoC resource will not be NACK’d.  Instead
 the tisci_msg_rm_get_resource_range_resp range_start and range_num values are
 both zeroed.  This provides a known response mechanism across varied SoCs.
 Populating secondary_host with &#64;ref TISCI_MSG_VALUE_RM_UNUSED_SECONDARY_HOST
 specifies the value as unused.</p>
</p>
<p><p><strong>struct tisci_msg_rm_get_resource_range_resp</strong></p>
<p>Get resource range response message</p>
<table border="1" class="docutils">
<colgroup>
<col width="10%" />
<col width="12%" />
<col width="78%" />
</colgroup>
<thead valign="bottom">
<tr class="row-odd"><th class="head">Parameter</th>
<th class="head">Type</th>
<th class="head">Description</th>
</tr>
</thead>
<tbody valign="top">
<tr class="row-even"><td>hdr</td>
<td>struct tisci_header</td>
<td>Standard TISCI header</td>
</tr>
<tr class="row-odd"><td>range_start</td>
<td>u16</td>
<td>Start index of retrieved resource range.</td>
</tr>
<tr class="row-even"><td>range_num</td>
<td>u16</td>
<td>Number of resources in the range.  Zero if the resource is not valid.</td>
</tr>
<tr class="row-odd"><td>range_start_sec</td>
<td>u16</td>
<td>Start index of retrieved secondary resource range.  Zero if a second resource range does not exist or if the resource is not valid.</td>
</tr>
<tr class="row-even"><td>range_num_sec</td>
<td>u16</td>
<td>Number of resources in secondary range.  Zero if a second resource range does not exist or if the resource is not valid.</td>
</tr>
</tbody>
</table>
<p>Response sent to host processor containing the requested resource range
 assigned to the host who sent the range request.
 The range_start and range_num values are BOTH zero if the type and subtype
 in the range request do not form a unique resource type for the SoC.  In
 this case, the response will still contain an ACK.</p>
</p>
<div class="admonition warning">
<p class="first admonition-title">Warning</p>
<p class="last">The boardcfg data structures described below <strong>must</strong> be placed in
MCU OCMC SRAM. The address used in the TISCI message will be
in MCU OCMC SRAM.</p>
</div>
<div class="section" id="boardcfg-rm-structure">
<span id="pub-boardcfg-rm"></span><h4>boardcfg_rm structure<a class="headerlink" href="#boardcfg-rm-structure" title="Permalink to this headline">¶</a></h4>
<table border="1" class="docutils">
<colgroup>
<col width="13%" />
<col width="43%" />
<col width="43%" />
</colgroup>
<thead valign="bottom">
<tr class="row-odd"><th class="head">Field</th>
<th class="head">Type</th>
<th class="head">Description</th>
</tr>
</thead>
<tbody valign="top">
<tr class="row-even"><td>rev</td>
<td><a class="reference internal" href="BOARDCFG.html#pub-boardcfg-abi-rev"><span class="std std-ref">ABI revision structure</span></a></td>
<td>Resource Management board
config ABI version (separate
from primary board config ABI
version)</td>
</tr>
<tr class="row-odd"><td>host_cfg</td>
<td><a class="reference internal" href="#pub-boardcfg-rm-host-cfg"><span class="std std-ref">boardcfg_rm_host_cfg structure</span></a></td>
<td>Host configuration structure</td>
</tr>
<tr class="row-even"><td>resasg</td>
<td><a class="reference internal" href="#pub-boardcfg-rm-resasg"><span class="std std-ref">boardcfg_rm_resasg structure</span></a></td>
<td>Resource assignment
configuration structure</td>
</tr>
</tbody>
</table>
</div>
<div class="section" id="boardcfg-rm-host-cfg-structure">
<span id="pub-boardcfg-rm-host-cfg"></span><h4>boardcfg_rm_host_cfg structure<a class="headerlink" href="#boardcfg-rm-host-cfg-structure" title="Permalink to this headline">¶</a></h4>
<table border="1" class="docutils">
<colgroup>
<col width="19%" />
<col width="49%" />
<col width="32%" />
</colgroup>
<thead valign="bottom">
<tr class="row-odd"><th class="head">Field</th>
<th class="head">Type</th>
<th class="head">Description</th>
</tr>
</thead>
<tbody valign="top">
<tr class="row-even"><td>subhdr</td>
<td><a class="reference internal" href="BOARDCFG.html#pub-boardcfg-subhdr"><span class="std std-ref">boardcfg substructure header</span></a></td>
<td>Magic and size for integrity
check</td>
</tr>
<tr class="row-odd"><td>host_cfg_entries</td>
<td><a class="reference internal" href="#pub-boardcfg-rm-host-cfg-entry"><span class="std std-ref">boardcfg_rm_host_cfg_entry structure</span></a> [32]</td>
<td>Array sized for scalable
number of hosts describing
each host’s configuration
attributes</td>
</tr>
</tbody>
</table>
</div>
<div class="section" id="boardcfg-rm-host-cfg-entry-structure">
<span id="pub-boardcfg-rm-host-cfg-entry"></span><h4>boardcfg_rm_host_cfg_entry structure<a class="headerlink" href="#boardcfg-rm-host-cfg-entry-structure" title="Permalink to this headline">¶</a></h4>
<p>The boardcfg_rm_host_cfg_entry structure describes a host’s configuration
attributes</p>
<table border="1" class="docutils">
<colgroup>
<col width="32%" />
<col width="8%" />
<col width="61%" />
</colgroup>
<thead valign="bottom">
<tr class="row-odd"><th class="head">Field</th>
<th class="head">Type</th>
<th class="head">Description</th>
</tr>
</thead>
<tbody valign="top">
<tr class="row-even"><td>host_id</td>
<td>u8</td>
<td>Processing entity host ID</td>
</tr>
<tr class="row-odd"><td>allowed_atype</td>
<td>u8</td>
<td>Deprecated. No longer used by SYSFW</td>
</tr>
<tr class="row-even"><td>allowed_qos</td>
<td>u16</td>
<td>Deprecated. No longer used by SYSFW</td>
</tr>
<tr class="row-odd"><td>allowed_orderid</td>
<td>u32</td>
<td>Deprecated. No longer used by SYSFW</td>
</tr>
<tr class="row-even"><td>allowed_priority</td>
<td>u16</td>
<td>Deprecated. No longer used by SYSFW</td>
</tr>
<tr class="row-odd"><td>allowed_sched_priority</td>
<td>u8</td>
<td>Deprecated. No longer used by SYSFW</td>
</tr>
</tbody>
</table>
</div>
<div class="section" id="boardcfg-rm-resasg-structure">
<span id="pub-boardcfg-rm-resasg"></span><h4>boardcfg_rm_resasg structure<a class="headerlink" href="#boardcfg-rm-resasg-structure" title="Permalink to this headline">¶</a></h4>
<table border="1" class="docutils">
<colgroup>
<col width="22%" />
<col width="41%" />
<col width="38%" />
</colgroup>
<thead valign="bottom">
<tr class="row-odd"><th class="head">Field</th>
<th class="head">Type</th>
<th class="head">Description</th>
</tr>
</thead>
<tbody valign="top">
<tr class="row-even"><td>subhdr</td>
<td><a class="reference internal" href="BOARDCFG.html#pub-boardcfg-subhdr"><span class="std std-ref">boardcfg substructure header</span></a></td>
<td>Magic and size for integrity check</td>
</tr>
<tr class="row-odd"><td>resasg_entries_size</td>
<td>u16</td>
<td>Size of resource assignment entry
array in bytes</td>
</tr>
<tr class="row-even"><td>reserved</td>
<td>u16</td>
<td>Reserved to keep 4-byte alignment</td>
</tr>
<tr class="row-odd"><td>resasg_entries</td>
<td><a class="reference internal" href="#pub-boardcfg-rm-resasg-entry"><span class="std std-ref">boardcfg_rm_resasg_entry (resource assignment) structure</span></a> []</td>
<td>Array of resource assignment entries
defined as variable length array.
The user must define their own
structure with a fixed length array
in place of resasg_entries[].</td>
</tr>
</tbody>
</table>
<p>Example user structure for RM boardcfg:</p>
<div class="code c highlight-cpp"><div class="highlight"><pre><span></span><span class="cp">#define RESASG_ENTRIES (100)</span>

<span class="k">struct</span><span class="w"> </span><span class="nc">local_rm_boardcfg</span><span class="w"> </span><span class="p">{</span>
<span class="w">    </span><span class="k">struct</span><span class="w"> </span><span class="nc">boardcfg_rm</span><span class="w">        </span><span class="n">rm_boardcfg</span><span class="p">;</span>
<span class="w">    </span><span class="k">struct</span><span class="w"> </span><span class="nc">boardcfg_rm_resasg_entry</span><span class="w">    </span><span class="n">resasg_entries</span><span class="p">[</span><span class="n">RESASG_ENTRIES</span><span class="p">];</span>
<span class="p">};</span>
</pre></div>
</div>
</div>
<div class="section" id="boardcfg-rm-resasg-entry-resource-assignment-structure">
<span id="pub-boardcfg-rm-resasg-entry"></span><h4>boardcfg_rm_resasg_entry (resource assignment) structure<a class="headerlink" href="#boardcfg-rm-resasg-entry-resource-assignment-structure" title="Permalink to this headline">¶</a></h4>
<p>There is one boardcfg_rm_resasg_entry per resource per host. This structure
allows one contiguous block of any resource to be assigned to one processing
entity</p>
<table border="1" class="docutils">
<colgroup>
<col width="21%" />
<col width="8%" />
<col width="71%" />
</colgroup>
<thead valign="bottom">
<tr class="row-odd"><th class="head">Field</th>
<th class="head">Type</th>
<th class="head">Description</th>
</tr>
</thead>
<tbody valign="top">
<tr class="row-even"><td>start_resource</td>
<td>u16</td>
<td>First resource number (inclusive) for this host_id
and resource type</td>
</tr>
<tr class="row-odd"><td>num_resource</td>
<td>u16</td>
<td>Number of continuous resources allocated to this
host_id and resource type. 0 means unused</td>
</tr>
<tr class="row-even"><td>type</td>
<td>u16</td>
<td>Unique type value identifying the resource whose
range is assigned to host_id</td>
</tr>
<tr class="row-odd"><td>host_id</td>
<td>u8</td>
<td>Host ID as defined in secure proxy configuration</td>
</tr>
<tr class="row-even"><td>reserved</td>
<td>u8</td>
<td>Byte reservation to assure contiguous resasg entries
are aligned on 8-byte boundaries</td>
</tr>
</tbody>
</table>
</div>
<div class="section" id="design-details-for-interrupt-management">
<h4>Design details for interrupt management<a class="headerlink" href="#design-details-for-interrupt-management" title="Permalink to this headline">¶</a></h4>
<p>Within interrupt management, interrupts are routed through interrupt aggregators
(IAs) and interrupt routers (IRs).</p>
<p>Whenever interrupt routers broadcast the interrupt to multiple interrupt
controllers then it is possible for one processing entity to take outputs that
could have been used by another processing entity, precluding the second
processing entity from routing a required interrupt. Thus IRs with broadcast
outputs need resource reservation capability. On AM6, these are the GPIO
interrupt routers (in main and mcu), as well as the MAIN2MCU interrupt router.</p>
<p>Each interrupt aggregator virtual interrupt allows grouping up to 64
peripheral events to one host interrupt. It’s possible for one host to
take all of these virtual interrupts.  It’s also possible for one host to take
all peripheral events.  Thus, resource reservation capability is required for
peripheral events and interrupt aggregator virtual interrupts.</p>
<p>Interrupt routes terminate at host processor interrupt controller inputs.  A
single host is capable of consuming all interrupt controller intputs.
Therefore, resource reservation is required for host processor interrupt
controller IRQs.</p>
<p>The unique types used to identify interrupt management reserved resources are
found in <a class="reference internal" href="../5_soc_doc/am65x/resasg_types.html"><span class="doc">Enumeration of Resource Type IDs</span></a>.</p>
</div>
</div>
</div>
<div class="section" id="resource-management-initialization-after-receiving-board-configuration">
<h2>Resource Management Initialization after receiving board configuration<a class="headerlink" href="#resource-management-initialization-after-receiving-board-configuration" title="Permalink to this headline">¶</a></h2>
<p>Once the RM board configuration message is received by the System Firmware, it
performs the following operations:</p>
<div class="section" id="board-configuration-receive-and-validate">
<h3>Board Configuration Receive and Validate<a class="headerlink" href="#board-configuration-receive-and-validate" title="Permalink to this headline">¶</a></h3>
<p>The first step after receiving the board configuration by the tisci_msg_board_config_rm_handler
is to copy the board configuration into the local memory of the DMSC. The input
is validated for ABI check and size checks.</p>
<div class="admonition warning">
<p class="first admonition-title">Warning</p>
<p class="last">The board configuration is assumed
to be pre-sorted and validated using the script sysfw_boardcfg_validator.py.
If the data is not pre-sorted the behavior of the RM functionality is undefined.</p>
</div>
<img alt="../_images/RM_BRD_CFG_2.JPG" src="../_images/RM_BRD_CFG_2.JPG" />
</div>
<div class="section" id="rm-core-initialization">
<h3>RM Core Initialization<a class="headerlink" href="#rm-core-initialization" title="Permalink to this headline">¶</a></h3>
<p>The next step of the tisci_msg_board_config_rm_handler is to perform the RM Core
initialization. This involves initialization of software structures to create an
index to the resource assignment local copy for faster run time access. In addition
the code also registers the software handler for the
<a class="reference internal" href="#pub-boardcfg-resasg-get-tisci"><span class="std std-ref">TISCI_MSG_RM_GET_RESOURCE_RANGE</span></a> message.</p>
<img alt="../_images/RM_BRD_CFG_3.JPG" src="../_images/RM_BRD_CFG_3.JPG" />
</div>
<div class="section" id="rm-irq-initialization">
<h3>RM IRQ Initialization<a class="headerlink" href="#rm-irq-initialization" title="Permalink to this headline">¶</a></h3>
<p>The next step of the tisci_msg_board_config_rm_handler is to perform the RM IRQ
initialization. As part of this step the code initializes the Dev group specific
IR and IA for proxy response and notify messages. List of what is to be initialized
is SoC specific and based on the secure proxy configuration.</p>
<p>In addition
the code also registers the software handler for the</p>
<ul class="simple">
<li><a class="reference internal" href="../2_tisci_msgs/rm/rm_irq.html#pub-rm-irq-route-set"><span class="std std-ref">TISCI_MSG_RM_IRQ_SET</span></a> message</li>
<li><a class="reference internal" href="../2_tisci_msgs/rm/rm_irq.html#pub-rm-irq-route-release"><span class="std std-ref">TISCI_MSG_RM_IRQ_RELEASE</span></a> message.</li>
</ul>
<p>It also initializes software state information capture in the internal structures
of ir_instance. This is a SoC specific System Firmware internal structure which is
used to manage the Interrupt Router resource.</p>
<p>The IR initialization sequence is as below:</p>
<img alt="../_images/RM_BRD_CFG_4.JPG" src="../_images/RM_BRD_CFG_4.JPG" />
<p>The IA initialization sequence is as below:</p>
<img alt="../_images/RM_BRD_CFG_5.JPG" src="../_images/RM_BRD_CFG_5.JPG" />
</div>
<div class="section" id="rm-ring-accelerator-initialization">
<h3>RM Ring Accelerator initialization<a class="headerlink" href="#rm-ring-accelerator-initialization" title="Permalink to this headline">¶</a></h3>
<p>The next step of the tisci_msg_board_config_rm_handler is to perform the RM
Ring Accelerator initialization. As part of this step the code initializes the
Output Event Steering software handlers.</p>
<p>In addition
the code also registers the software handler for the</p>
<ul class="simple">
<li><a class="reference internal" href="../2_tisci_msgs/rm/rm_ra.html#pub-rm-public-ra-cfg"><span class="std std-ref">TISCI_MSG_RM_RING_CFG</span></a> message</li>
<li><a class="reference internal" href="../2_tisci_msgs/rm/rm_ra.html#pub-rm-public-ra-mon-cfg"><span class="std std-ref">TISCI_MSG_RM_RING_MON_CFG</span></a> message</li>
</ul>
<p>It also initializes software state information capture in the internal structures
of ra_instance. This is a SoC specific System Firmware internal structure which is
used to manage the ring accelerator resource.</p>
<img alt="../_images/RM_BRD_CFG_6.JPG" src="../_images/RM_BRD_CFG_6.JPG" />
</div>
<div class="section" id="rm-dma-initialization">
<h3>RM DMA Initialization<a class="headerlink" href="#rm-dma-initialization" title="Permalink to this headline">¶</a></h3>
<p>The next step of the tisci_msg_board_config_rm_handler is to perform the RM
DMA initialization. As part of this step the code initializes the
Output Event Steering software handlers. At this point the code also programs
the DRU PSIL Thread ID and program in UDMA_UTC_CTRL for SoCs which support DRU.</p>
<p>In addition
the code also registers the software handler for the</p>
<ul class="simple">
<li><a class="reference internal" href="../2_tisci_msgs/rm/rm_udmap.html#pub-rm-public-udmap-gcfg-cfg"><span class="std std-ref">TISCI_MSG_RM_UDMAP_GCFG_CFG</span></a> message</li>
<li><a class="reference internal" href="../2_tisci_msgs/rm/rm_udmap.html#pub-rm-public-udmap-tx-ch-cfg"><span class="std std-ref">TISCI_MSG_RM_UDMAP_TX_CH_CFG</span></a> message</li>
<li><a class="reference internal" href="../2_tisci_msgs/rm/rm_udmap.html#pub-rm-public-udmap-rx-ch-cfg"><span class="std std-ref">TISCI_MSG_RM_UDMAP_RX_CH_CFG</span></a> message</li>
<li><a class="reference internal" href="../2_tisci_msgs/rm/rm_udmap.html#pub-rm-public-udmap-flow-cfg"><span class="std std-ref">TISCI_MSG_RM_UDMAP_FLOW_CFG</span></a> message</li>
<li><a class="reference internal" href="../2_tisci_msgs/rm/rm_udmap.html#pub-rm-public-udmap-flow-size-thresh-cfg"><span class="std std-ref">TISCI_MSG_RM_UDMAP_FLOW_SIZE_THRESH_CFG</span></a> message</li>
</ul>
<img alt="../_images/RM_BRD_CFG_7.JPG" src="../_images/RM_BRD_CFG_7.JPG" />
</div>
<div class="section" id="rm-psil-initialization">
<h3>RM PSIL Initialization<a class="headerlink" href="#rm-psil-initialization" title="Permalink to this headline">¶</a></h3>
<p>The next step of the tisci_msg_board_config_rm_handler is to perform the RM
PSIL initialization. At this step the code registers the software handler for the</p>
<ul class="simple">
<li><a class="reference internal" href="../2_tisci_msgs/rm/rm_psil.html#pub-rm-public-psil-pair"><span class="std std-ref">TISCI_MSG_RM_PSIL_PAIR</span></a> message</li>
<li><a class="reference internal" href="../2_tisci_msgs/rm/rm_psil.html#pub-rm-public-psil-unpair"><span class="std std-ref">TISCI_MSG_RM_PSIL_UNPAIR</span></a> message</li>
<li><a class="reference internal" href="../2_tisci_msgs/rm/rm_psil.html#pub-rm-public-psil-read"><span class="std std-ref">TISCI_MSG_RM_PSIL_READ</span></a> message</li>
<li><a class="reference internal" href="../2_tisci_msgs/rm/rm_psil.html#pub-rm-public-psil-write"><span class="std std-ref">TISCI_MSG_RM_PSIL_WRITE</span></a> message</li>
</ul>
<img alt="../_images/RM_BRD_CFG_8.JPG" src="../_images/RM_BRD_CFG_8.JPG" />
</div>
<div class="section" id="rm-proxy-initialization">
<h3>RM Proxy Initialization<a class="headerlink" href="#rm-proxy-initialization" title="Permalink to this headline">¶</a></h3>
<p>The next step of the tisci_msg_board_config_rm_handler is to perform the RM
Proxy initialization. As part of this step the code initializes the
Output Event Steering software handlers.</p>
<p>In addition the code also registers the software handler for the</p>
<ul class="simple">
<li><a class="reference internal" href="../2_tisci_msgs/rm/rm_proxy.html#pub-rm-public-proxy-cfg"><span class="std std-ref">TISCI_MSG_RM_PROXY_CFG</span></a> message</li>
</ul>
<img alt="../_images/RM_BRD_CFG_9.JPG" src="../_images/RM_BRD_CFG_9.JPG" />
</div>
<div class="section" id="osal-rm-subsystem-init">
<h3>OSAL RM Subsystem Init<a class="headerlink" href="#osal-rm-subsystem-init" title="Permalink to this headline">¶</a></h3>
<p>This is the last step in tisci_msg_board_config_rm_handler where the software
state is updated to reflect the resource management is initialized and now
can accept resource management messages.</p>
<p>After this step the host response is sent. If for any reason any of the above
steps fail the API would return with a NACK.</p>
<img alt="../_images/RM_BRD_CFG_10.JPG" src="../_images/RM_BRD_CFG_10.JPG" />
</div>
</div>
</div>


           </div>
          </div>
          <footer>
  
    <div class="rst-footer-buttons" role="navigation" aria-label="footer navigation">
      
        <a href="BOARDCFG_SEC.html" class="btn btn-neutral float-right" title="Security Board Configuration" accesskey="n">Next <span class="fa fa-arrow-circle-right"></span></a>
      
      
        <a href="BOARDCFG.html" class="btn btn-neutral" title="Board Configuration" accesskey="p"><span class="fa fa-arrow-circle-left"></span> Previous</a>
      
    </div>
  

  <hr/>

  <div role="contentinfo">
    <p>
      <a href="http://www.ti.com/corp/docs/legal/copyright.shtml">&copy; Copyright 2016-2025</a>, Texas Instruments Incorporated. All rights reserved. <br>
      <a href="http://www.ti.com/corp/docs/legal/trademark/trademrk.htm">Trademarks</a> | <a href="http://www.ti.com/corp/docs/legal/privacy.shtml">Privacy policy</a> | <a href="http://www.ti.com/corp/docs/legal/termsofuse.shtml">Terms of use</a> | <a href="http://www.ti.com/lsds/ti/legal/termsofsale.page">Terms of sale</a>

    </p>
  </div> 

</footer>

        </div>
      </div>

    </section>

  </div>
  


  

    <script type="text/javascript">
        var DOCUMENTATION_OPTIONS = {
            URL_ROOT:'../',
            VERSION:'11.00.04',
            COLLAPSE_INDEX:false,
            FILE_SUFFIX:'.html',
            HAS_SOURCE:  true
        };
    </script>
      <script type="text/javascript" src="../_static/jquery.js"></script>
      <script type="text/javascript" src="../_static/underscore.js"></script>
      <script type="text/javascript" src="../_static/doctools.js"></script>
      <script type="text/javascript" src="https://cdnjs.cloudflare.com/ajax/libs/mathjax/2.7.1/MathJax.js?config=TeX-AMS-MML_HTMLorMML"></script>

    <script src="http://www.ti.com/assets/js/headerfooter/analytics.js" type="text/javascript" charset="utf-8"></script>

  

  
  
    <script type="text/javascript" src="../_static/js/theme.js"></script>
  

  
  
  <script type="text/javascript">
      jQuery(function () {
          SphinxRtdTheme.StickyNav.enable();
        });

      var menuHeight = window.innerHeight;

      var contentOffset = $(".wy-nav-content-wrap").offset();
      var contentHeight = $(".wy-nav-content-wrap").height();
      var contentBottom = contentOffset.top + contentHeight;

      function setNavbarTop() {
          var scrollTop = $(window).scrollTop();
          var maxTop = scrollTop + menuHeight;

          // If past the header
          if (scrollTop > contentOffset.top && maxTop < contentBottom) {
            stickyTop = scrollTop - contentOffset.top;
          } else if (maxTop > contentBottom) {
            stickyTop = scrollTop - contentOffset.top - (maxTop - contentBottom);
          } else {
            stickyTop = 0;
          }

          $(".wy-nav-side").css("top", stickyTop);
      }

      $(document).ready(function() {
        setNavbarTop();
        $(window).scroll(function () {
          setNavbarTop();
        });

        $('body').on("mousewheel", function () {
            // Remove default behavior
            event.preventDefault();
            // Scroll without smoothing
            var wheelDelta = event.wheelDelta;
            var currentScrollPosition = window.pageYOffset;
            window.scrollTo(0, currentScrollPosition - wheelDelta);
        });
      });
  </script>
   

</body>
</html>